<%@ include file="init_inc.jsp" %>
<%@ include file="checkauth_inc.jsp" %>
<%@ include file="course_inc.jsp" %>
<%@ include file="exercise_inc.jsp" %>
<%@ include file="header.jsp" %>

<%@ page import="java.sql.*" %>
<%@ page import="java.util.*" %>
<%@ page import="no.ntnu.stud.frodesol.jexserver.core.*" %>
<%@ page import="no.ntnu.stud.frodesol.jexserver.eval.*" %>

<%
if (jexuser.isAdmin ()) {
%>

<h1>Exercise Statistics</h1>

<table>
<%
Database database = Database.getInstance ();
PreparedStatement stat;
ResultSet rs;
int intval;
%>

<tr>
<td>Total manual submissions:</td>
<td>
<%
stat = database.prepareStatement ("SELECT count(*) FROM submission WHERE autosubmitted = 0 AND exercise = ?");
stat.setString (1, jexexercise.getId ());
rs = stat.executeQuery ();
rs.next ();
intval = rs.getInt (1);
rs.close ();
stat.close ();
%>
<%=intval%>
</td>
</tr>

<tr>
<td>Total automatic submissions:</td>
<td>
<%
stat = database.prepareStatement ("SELECT count(*) FROM submission WHERE autosubmitted = 1 AND exercise = ?");
stat.setString (1, jexexercise.getId ());
rs = stat.executeQuery ();
rs.next ();
intval = rs.getInt (1);
rs.close ();
stat.close ();
%>
<%=intval%>
</td>
</tr>

<tr>
<td>Number of unique students:</td>
<td>
<%
stat = database.prepareStatement ("SELECT DISTINCT student FROM submission WHERE exercise = ?");
stat.setString (1, jexexercise.getId ());
rs = stat.executeQuery ();
rs.last ();
intval = rs.getRow ();
rs.close ();
stat.close ();
%>
<%=intval%>
</td>
</tr>

<tr>
<td>Number of students having achieved perfect score:</td>
<td>
<%
stat = database.prepareStatement ("SELECT DISTINCT student FROM submission WHERE exercise = ? AND score = 100");
stat.setString (1, jexexercise.getId ());
rs = stat.executeQuery ();
rs.last ();
intval = rs.getRow ();
rs.close ();
stat.close ();
%>
<%=intval%>
</td>
</tr>



</table>

<h2>Score Visualization</h2>

<p>
<%


stat = database.prepareStatement (
"select sid, test, points from (select student, max(id) as sid from submission where exercise = ? AND score is not null group by student) as s, submission, scoring where submission.id = sid and scoring.submission = sid order by sid desc, test asc;"
);
stat.setString (1, jexexercise.getId ());
rs = stat.executeQuery ();
//int firstrow
int cursubmission = -1;
String htmlfrag = "";
while (rs.next ()) {
    //if (rs.getRow () == 1) {
    //    
    //}
    int sid = rs.getInt (1);
    if (sid != cursubmission) {
        if (htmlfrag.length () > 0) {
            %>
            <div class="row"><%=htmlfrag%></div>
            <%
        }
        cursubmission = sid;
        htmlfrag = "";
    }
    int test = rs.getInt (2);
    int points = rs.getInt (3);
    String divclass = "failed";
    if (points > 0) {
        divclass = "success";
    }
    htmlfrag += "<div class='" + divclass + "'>" + test + "</div>";
}
stat.close ();
if (htmlfrag.length () > 0) {
    %>
    <div class="row"><%=htmlfrag%></div>
    <%
}

%>
<p style='clear: both'><br/></p>

<h2>Legend</h2>

<table>
<%

if (cursubmission > -1) {
    Submission sub = Submission.get (cursubmission);
    Report report = sub.createReport ();
    TestNode[] nodes = report.getTestNodes ();
    for (int i = 0; i < nodes.length; i++) {
        if (nodes[i].getMaxPoints () > 0) {
            %>
            <tr><td><b><%=i%> &nbsp; </b></td>
            <td><%=nodes[i].getName ()%></td>
            </tr>
            <%
        }
    }
}

%>
</table>
<%

}
%>

<%@ include file="footer.jsp" %>
