<%@ include file="init_inc.jsp" %>
<%@ include file="course_inc.jsp" %>
<%@ include file="exercise_inc.jsp" %>

<%@ page import="java.sql.*" %>
<%@ page import="java.util.*" %>
<%@ page import="no.ntnu.stud.frodesol.jexserver.core.*" %>
<%@ page import="no.ntnu.stud.frodesol.jexserver.eval.*" %>

<html>
<head><title>JExercise Grading Server</title>
<style>

div.row {
    width: 100%;
    clear: both;
}

div.success text {
    display: none;
}

div.success {
    margin: 1px;
    padding: 1px;
    float: left;
    background-color: #00ee00;
    color: white;
    font-size: 10px;
    width: 20px;
}
div.failed {
    margin: 1px;
    padding: 1px;
    float: left;
    background-color: red;
    color: white;
    font-size: 10px;
    width: 20px;
}

</style>
</head>
<body>
<%
Database database = Database.getInstance ();
PreparedStatement stat;
ResultSet rs;
int intval;
%>


<%

stat = database.prepareStatement (
"select sid, test, points from (select student, max(id) as sid from submission where exercise = ? AND score is not null group by student) as s, submission, scoring where submission.id = sid and scoring.submission = sid order by sid desc, test asc;"
);
stat.setString (1, jexexercise.getId ());
rs = stat.executeQuery ();
//int firstrow
int cursubmission = -1;
String htmlfrag = "";
while (rs.next ()) {
    //if (rs.getRow () == 1) {
    //    
    //}
    int sid = rs.getInt (1);
    if (sid != cursubmission) {
        if (htmlfrag.length () > 0) {
            %>
            <div class="row"><%=htmlfrag%></div>
            <%
        }
        cursubmission = sid;
        htmlfrag = "";
    }
    int test = rs.getInt (2);
    int points = rs.getInt (3);
    String divclass = "failed";
    if (points > 0) {
        divclass = "success";
    }
    htmlfrag += "<div class='" + divclass + "'>" + test + "</div>";
}
stat.close ();
if (htmlfrag.length () > 0) {
    %>
    <div class="row"><%=htmlfrag%></div>
    <%
}

%>
<p style='clear: both'><br/></p>

<h2>Legend</h2>

<table>
<%

if (cursubmission > -1) {
    Submission sub = Submission.get (cursubmission);
    Report report = sub.createReport ();
    TestNode[] nodes = report.getTestNodes ();
    for (int i = 0; i < nodes.length; i++) {
        if (nodes[i].getMaxPoints () > 0) {
            %>
            <tr><td><b><%=i%> &nbsp; </b></td>
            <td><%=nodes[i].getName ()%></td>
            </tr>
            <%
        }
    }
}

%>
</table>

</body>
</html>