package no.ntnu.stud.frodesol.jexserver.core;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

public class Course {
    
    private String m_id;
    private boolean m_loaded = false;
    private String m_code = "";
    private String m_name = "";
    
    public Course (String id) {
        m_id = id;
    }
    
    public String getId () throws Exception {
        return m_id;
    }
    
    public String getCode () throws Exception {
        load ();
        return m_code;
    }
    
    public String getName () throws Exception {
        load ();
        return m_name;
    }
    
    public List<Exercise> getExercises () throws Exception {
        
        Database database = Database.getInstance ();
        PreparedStatement stat = database.prepareStatement ("SELECT " +
                "uuid FROM exercise WHERE course = ?");
        stat.setString (1, m_id);
        ResultSet rs = stat.executeQuery ();
        
        ArrayList<Exercise> list = new ArrayList<Exercise> ();
        while (rs.next ()) {
            list.add (new Exercise (rs.getString (1)));
        }
        rs.close ();
        database.close ();
        
        return list;
    }
    
    public void load () throws Exception {
        
        if (m_loaded) return;
        
        Database database = Database.getInstance ();
        PreparedStatement stat = database.prepareStatement ("SELECT " +
                "NAME code, name FROM course WHERE id = ?");
        stat.setString (1, m_id);
        ResultSet rs = stat.executeQuery ();
        rs.next ();
        m_code = rs.getString (1);
        m_name = rs.getString (2);
        m_loaded = true;
        rs.close ();
        database.close ();
    }
}
