package no.ntnu.stud.frodesol.jexserver.core;

import no.ntnu.stud.frodesol.jexserver.*;
import java.io.File;
import java.sql.*;
import javax.sql.*;
import javax.naming.*;

public class Database {
    
    private static Database s_instance = null;
    
    public static Database getInstance () throws Exception {

        //return new Database ();
        if (s_instance == null) {
            Database db = new Database ();
            if (db.isPooled ()) {
                return db;
            }
            s_instance = db;
        }
        
        if (s_instance.m_conn == null) {
            s_instance.open ();
        }
        return s_instance;
    }
    
    Connection m_conn = null;
    boolean m_pooled = false;
    
    public Database () throws Exception {
        
        open ();
    }
    
    public void open () throws Exception {
        
        try {
            Context init_context = new InitialContext ();
            Context env_context  = (Context) init_context.lookup ("java:/comp/env");
            DataSource ds = (DataSource) env_context.lookup ("jdbc/jexserver");
            m_conn = ds.getConnection ();
            m_pooled = true;
        }
        catch (Exception e) {
            Class.forName ("com.mysql.jdbc.Driver");
            m_conn = DriverManager.getConnection (getConnectionString (),
                    "jexserver", JexEnv.getDatabasePassword ());
            m_pooled = false;
        }        
    }
    
    public void close () throws SQLException {
        
        if (m_pooled) {
            m_conn.close ();
            m_conn = null;
        }
        // no-op
        /*
        m_conn.close ();
        m_conn = null;
        */
    }
    
    public boolean isPooled () {
        return m_pooled;
    }
    
    public Statement createStatement () throws SQLException {
        
        return m_conn.createStatement ();
    }
    
    public PreparedStatement prepareStatement (String sql) throws SQLException {
        
        return m_conn.prepareStatement (sql);
    }
    
    public static String getConnectionString () {
        
        //File f = new File (JexEnv.getStorage (), "database.db");
        //return "jdbc:sqlite:" + f.getPath ();

        //File f = new File (JexEnv.getStorage (), "database.db");
        return "jdbc:mysql://localhost/jexserver";
    }
    
    
}
