package no.ntnu.stud.frodesol.jexserver.core;

import java.io.File;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class JexEnv {
	
    public static String getHome () {
        
        return System.getenv ("JEXSERVER_HOME");
    }
    
    public static String getStorage () {
        
        String path = System.getenv ("JEXSERVER_STORAGE");
        if (path == null) {
            try {
                Context env = (Context) new InitialContext ().lookup (
                        "java:comp/env");
                path = (String) env.lookup ("JEXSERVER_STORAGE");
            }
            catch (NamingException e) {
                
            }
        }
        return path;
    }
    
    public static String getDatabasePassword () {
        
        String path = System.getenv ("JEXSERVER_DBPASS");
        if (path == null) {
            try {
                Context env = (Context) new InitialContext ().lookup (
                        "java:comp/env");
                path = (String) env.lookup ("JEXSERVER_DBPASS");
            }
            catch (NamingException e) {
                
            }
        }
        return path;
    }
    
    public static String getEvalTemp () {
        
        return System.getenv ("JEXSERVER_TEMP");
    }
    
	public static String getJavaCommand () {
	    
	    String envvar = System.getenv ("JEXSERVER_JAVA");
	    if (envvar == null) {
	        return "java";
	    }
	    return envvar;
	}
	
	public static String getJavacCommand () {

	    String envvar = System.getenv ("JEXSERVER_JAVAC");
        if (envvar == null) {
            return "javac";
        }
        return envvar;
	}
	
	public static int getDispatcherPort () {
	    
	    // This is just a semi-randomly chosen port number
	    return 46129;
	}
	
    public static String getDispatcherHost () {
        
        // Hard-coded, for now
        // FIXME: Read from a configuration file, or environment
        // variable
        return "127.0.0.1";
    }
	
	public static String getSystemClassPath () {
		
	    String path = getHome () + File.separator + "bin" + 
	            File.pathSeparator + getHome () + File.separator + "junit.jar" +
	            File.pathSeparator + getHome () + File.separator + "jexserver.jar";
	    System.out.println (path);
	    return path;
	}
	
}
