package no.ntnu.stud.frodesol.jexserver.eval;

import javax.xml.parsers.*;
//import org.xml.sax.SAXException;

import org.w3c.dom.*;
//import org.w3c.dom.DOMException;
import java.io.*;

public class TestTreeLoader {
	
	public TestTree loadFromDir (String exdir) 
			throws ExerciseException { 
		
		File fname = getJexFilePath (exdir);
		return loadExcercise (fname.toString ());
	}
	
	public static File getJexFilePath (String exdir) {
		
		File fname = new File (exdir, "exercise.jex");
		return fname;
	}
	
	public static TestTree loadExcercise (String jexfile) 
			throws ExerciseException { 
		
		Document document = null;
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance ();
		factory.setNamespaceAware (true);
		try {
			DocumentBuilder builder = factory.newDocumentBuilder ();
			document = builder.parse (jexfile);
		} catch (Exception e) {
			throw new ExerciseException ("Failure loading " + jexfile + 
					": " + e.getMessage ());
		}
		
		TestTree etree = new TestTree (document);
		TestNode rootnode = etree.getRootNode ();
		Element element = document.getDocumentElement ();
		addRequirementsNodes (rootnode, element);
		
		return etree;
	}
	
	public static void addRequirementsNodes (TestNode parent,
			Element element) {
		
		 NodeList nlist = element.getChildNodes ();
		 for (int i = 0; i < nlist.getLength (); i++) {
			 org.w3c.dom.Node n = nlist.item (i);
			 if (n.getNodeName ().equals ("requirements") == false) continue;
			 
			 Element e = (Element) n;
			 String name = e.getAttribute ("text");
			 if (name.length () == 0) {
				 name = "Requirement";
			 }
			 
			 String type = e.getAttributeNS (
					 "http://www.w3.org/2001/XMLSchema-instance", "type");
			 String jepath = e.getAttribute ("javaElement");
			 TestNode newnode = new TestNode (name, type,
					 jepath);
			 
			 int points = 0;
			 try {
				 points = Integer.parseInt(e.getAttribute ("points"));
			 }
			 catch (Exception unused) {
				 
			 }
			 newnode.setMaxPoints (points);
			 parent.addChild (newnode);
			 addRequirementsNodes (newnode, e);
		 }
	}
}
