package no.ntnu.stud.frodesol.jexserver.util;

import no.ntnu.stud.frodesol.jexserver.core.*;
import java.sql.*;

public class CreateDatabase {
    
    /**
     * @param args
     */
    public static void main(String[] args) {
        
        try {
            
            int phase = Integer.parseInt (args[0]);
            switch (phase) {
                case 0: 
                createTables ();
                case 1:
                    update1 ();
                case 2:
                    update2 ();
                case 3:
                    update3 ();
            }
            
        }
        catch (Exception e) {
            e.printStackTrace ();
        }
        
    }
    
    public static void update1 () throws Exception {
        
        Database database = Database.getInstance ();
        Statement statement = database.createStatement ();
                
        statement.execute ("ALTER TABLE submission ADD COLUMN priority INT NOT NULL DEFAULT 0");
        statement.execute ("ALTER TABLE submission ADD COLUMN autosubmitted BOOLEAN NOT NULL DEFAULT false");

    }
    
    public static void update2 () throws Exception {
        
        Database database = Database.getInstance ();
        Statement statement = database.createStatement ();
                
        statement.execute ("alter table submission change receivetime receivetime datetime");

    }
    
    public static void update3 () throws Exception {
        
        Database database = Database.getInstance ();
        Statement statement = database.createStatement ();
                
        statement.execute ("alter table student add column data TEXT");
        
        statement.execute ("CREATE TABLE exerciseref (" +
                "id VARCHAR(128) PRIMARY KEY," +
                "student VARCHAR(36)," +
                "exercise VARCHAR(36)" +
                ")");
        /*
        statement.execute ("CREATE TABLE launchref (" +
                "id INT PRIMARY KEY," +
                "student VARCHAR(36)," +
                "exercise VARCHAR(36), " +
                "score INTEGER, " +
                ")");
        */
    }
    
    public static void createTables () throws Exception {
        
        // drop table scoring; drop table submission; drop table exercise; drop table attends; drop table student; drop table course;
        
        Database database = Database.getInstance ();
        Statement statement = database.createStatement ();
        
        System.out.println ("Creating tables");
        
        statement.execute ("CREATE TABLE course (" +
        		"id VARCHAR(20)," +
        		"code TEXT," +
        		"name TEXT" +
        		")");

        statement.execute ("INSERT INTO course (id, code, name) " +
                "VALUES ('TST1001-H07', 'TST1001', 'Test course')");
        statement.execute ("INSERT INTO course (id, code, name) " +
                "VALUES ('TDT4100-V08', 'TDT4100', 'Object-Oriented Programming')");
        
        statement.execute ("CREATE TABLE student (" +
                "username VARCHAR(36) PRIMARY KEY," +
                "password VARCHAR(36)," +
                "name TEXT," +
                "email TEXT," +
                "isadmin BOOLEAN DEFAULT false" +
                ")");
        
        statement.execute ("INSERT INTO student (username, password, " +
        		"name, email) " +
                "VALUES ('test', 'qwerty', 'Test User', NULL)");
        
        statement.execute ("INSERT INTO student (username, password, " +
                "name, email) " +
                "VALUES ('test2', 'qwerty', 'Test User', NULL)");
        
        statement.execute ("INSERT INTO student (username, password, " +
                "name, email, isadmin) " +
                "VALUES ('testadmin', 'qwerty', 'Test Admin', NULL, true)");
        
        statement.execute ("CREATE TABLE attends (" +
                "student VARCHAR(36)," +
                "course VARCHAR(20)" +
                ")");
        
        statement.execute ("INSERT INTO attends (student, course) " +
                "VALUES ('test', 'TST1001-H07')");
        statement.execute ("INSERT INTO attends (student, course) " +
        "VALUES ('test2', 'TDT4100-V08')");       
        statement.execute ("INSERT INTO attends (student, course) " +
        "VALUES ('testadmin', 'TDT4100-V08')");
        
        statement.execute ("CREATE TABLE exercise (" +
                "uuid VARCHAR(36)," +
                "course VARCHAR(20)," +
                "name TEXT," +
                "closetime DATETIME," +
                "version INTEGER" +
                ")");
        
        statement.execute ("INSERT INTO exercise (uuid, course, name," +
        		"version) " +
                "VALUES ('0965e81e-ba65-43e7-b512-2eee16e6aed0', " +
                "'TST1001-H07', 'Mid-term test exam', 0)");
        
        statement.execute ("CREATE TABLE submission (" +
                "id INTEGER PRIMARY KEY AUTO_INCREMENT," +
                "uuid VARCHAR(36)," +
                "student VARCHAR(36)," +
                "exercise VARCHAR(36)," +
                "receivetime TIMESTAMP," +
                "gradestarttime DATETIME," +
                "gradeendtime DATETIME," +
                "exversion INTEGER," +
                "score INTEGER" +
                ")");
        
        statement.execute ("INSERT INTO submission (uuid, student," +
        		"exercise, receivetime) " +
                "VALUES ('c77cfdbe-ce1f-4795-a5cb-245accd22949'," +
                "'test', '0965e81e-ba65-43e7-b512-2eee16e6aed0', " +
                "now())");
        
        /*
        statement.execute ("CREATE TABLE modifier (" +
                "submission INTEGER," +
        */
        statement.execute ("CREATE TABLE scoring (" +
                "submission INTEGER," +
                "test INTEGER," +
                "points INTEGER" +
                ")");        
        
        System.out.println ("Created tables");
    }

}
