package no.ntnu.stud.frodesol.jexserver.util;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class SocketFileUtil {
    
    static final int BUFFER_SIZE = 65536;
        
    public static void readFile (InputStream is, 
            String path) throws IOException {
        
        // Read four bytes of length information
        
        int length = is.read () * (1 << 24) + is.read () * (1 << 16) +
                is.read () * (1 << 8) + is.read ();
        System.out.println (" - incoming filesize is " + length);
        
        FileOutputStream fos = new FileOutputStream (path);
        byte[] buffer = new byte[BUFFER_SIZE];
        int readbytes = 0;
        while (readbytes < length) {
            int read = is.read (buffer, 0, Math.min (BUFFER_SIZE, 
                    length - readbytes));
            // Write bytes to file
            fos.write (buffer, 0, read);
            readbytes += read;
        }
        fos.close ();
        System.out.println (" - readFile completed");
    }
    
    public static void writeFile (OutputStream os, String filepath)
            throws IOException {
        
        // Max supported file size is 4G...
        File file = new File (filepath);
        int filesize = (int) file.length ();
        
        // We can do this because write only reads the 8 lower bits
        os.write (filesize >> 24);
        os.write (filesize >> 16);
        os.write (filesize >> 8);
        os.write (filesize);
        
        byte[] buffer = new byte[BUFFER_SIZE];
        FileInputStream fis = new FileInputStream (file);
        int readbytes = 0;
        while (readbytes < filesize) {
            int read = fis.read (buffer, 0, Math.min (BUFFER_SIZE, 
                    filesize - readbytes));
            os.write (buffer, 0, read);
            readbytes += read;
        }
        fis.close ();
    }
}
