package no.ntnu.stud.frodesol.jexserver.util;

import java.io.*;
import java.util.zip.*;
import java.util.*;

public class Util {
    
    static public void deleteFolder (String dirpath) throws IOException {
        
        File f = new File (dirpath);
        String[] dirlist = f.list ();
        for (int i = 0; i < dirlist.length; i++) {
            String name = dirlist[i];
            File f2 = new File (dirpath, name);
            if (f2.isDirectory ()) {
                deleteFolder (f2.getPath ());
            }
            else {
                boolean result = f2.delete ();
                if (result == false) {
                    throw new java.io.IOException (
                            "Could not delete file " + f2.getPath ());
                }
            }
        }
        f.delete ();
    }
    
    static public void unzipFile (String zippath, String destdir)
            throws IOException {
        
        System.out.println ("Unzip file " + zippath);
        System.out.println (" - into " + destdir);
        
        File destdir_f = new File (destdir);
        destdir_f.mkdirs ();
        
        ZipFile zipfile = new ZipFile (zippath);
        Enumeration entries = zipfile.entries ();
        while (entries.hasMoreElements()) {
            
            ZipEntry entry = (ZipEntry) entries.nextElement ();
            File f = new File (destdir, entry.getName ());
            if (f.getCanonicalPath ().startsWith (
                    destdir_f.getCanonicalPath ()) == false) {
                throw new IOException ("Tried to unzip outside directory!");
            }
            
            if (entry.isDirectory ()) {
                f.mkdirs ();
            }
            else {
                new File (f.getParent ()).mkdirs ();
                FileOutputStream fos = new FileOutputStream (f.getPath ());
                InputStream is = zipfile.getInputStream (entry);
                
                byte[] buffer = new byte[16384];
                int read = is.read (buffer);
                while (read > 0) {
                    fos.write (buffer, 0, read);
                    read = is.read (buffer);
                }
                is.close ();
                fos.close ();
            }
        }
        
        zipfile.close ();
    }
}
