package no.ntnu.stud.frodesol.jexweb;
import javax.servlet.http.*;
import javax.servlet.*;

import java.io.*;
import no.ntnu.stud.frodesol.jexserver.core.*;

import java.sql.*;
import java.util.*;
import org.apache.tomcat.util.http.fileupload.*;
import java.net.URLEncoder;

public class ApiSubmitServlet extends BaseServlet {
    
    public void doPost (HttpServletRequest request,
            HttpServletResponse response)
            throws ServletException, IOException {
        
        //ServletContext context = getServletContext ();

        String courseid = "";
        String exerciseid = "";
        Student student = null;
        String redirecturl = null;
        
        String exerciseref = request.getParameter ("exerciseref");
        if (exerciseref != null) {
            PreparedStatement stat = null;
            try {
                Database database = Database.getInstance ();
                stat = database.prepareStatement ("SELECT " +
                		"exerciseref.student, exerciseref.exercise, " +
                		"course.id FROM " +
                        "exerciseref, exercise, course WHERE " +
                        "exerciseref.exercise = " +
                        "exercise.uuid AND exercise.course = course.id " +
                        "AND exerciseref.id = ?");
                stat.setString(1, exerciseref);
                ResultSet rs = stat.executeQuery();
                if (!rs.next()) {
                    throw new Exception("Did not find exerciseref");
                }
                String username = rs.getString(1);
                exerciseid = rs.getString(2);
                courseid = rs.getString(3);
                rs.close();
                database.close();
                
                student = Student.findByCredentials(username, false);
            }
            catch (Exception e) {
                throw new ServletException(e);
            }
            finally {
                try {
                    if (stat != null) stat.close();
                }
                catch (Exception e) {
                    throw new ServletException(e);
                }
            }
            redirecturl = "http://" + request.getServerName () + ":" + 
                    request.getServerPort () + 
                    "/jexweb/itslearning/jexview.jsp?exerciseref=" +
                    URLEncoder.encode (exerciseref, "UTF-8");
        }
        else {
            courseid = request.getParameter ("courseid");
            if (courseid == null) {
                response.sendError (400, "No courseid specified");
                return;
            }
            if (courseid.compareTo ("TDT4100-2008") == 0) {
                courseid = "TDT4100-V08";
            }
            
            try {
                student = getStudent (request, true); 
            }
            catch (Exception e) {
                //response.sendRedirect ("login.jsp");
                System.out.println(e.getMessage());
                response.sendError (401, "Failure logging in");
                return;
            }
            
            try {
                student.attendCourse (courseid);
            }
            catch (Exception e) {
                response.sendError (500, "Error adding student to course");
            }
            exerciseid = request.getParameter ("exerciseid");
            if (exerciseid == null) {
                exerciseid = request.getParameter ("amp;exerciseid");
                if (exerciseid == null) {
                    response.sendError (400, "No exerciseid specified");
                    return;
                }
            }
        }
        Exercise exercise;// = new Exercise (exerciseid);
        try {
            exercise = Exercise.get (exerciseid);
        }
        catch (Exception e) {
            try {
                exercise = Exercise.findByNameAndCourse (exerciseid, courseid);
            }
            catch (Exception e2) {            
                response.sendError (500, "Could not load exercise");
                return;
            }
        }
        // FIXME: Check that the student is allowed to access the
        // exercise+course
        
        Submission submission;
        
        FileUpload fileupload = new FileUpload ();
        fileupload.setFileItemFactory (new DefaultFileItemFactory ());
        try {
            List<FileItem> fileitems = fileupload.parseRequest (request);
            // There should be only one file
            FileItem fileitem = fileitems.get (0);
            
            submission = new Submission (exercise, student);
            fileitem.write (new java.io.File (submission.getZipFilePath ()));
            
            if (request.getParameter ("auto") != null &&
                    request.getParameter ("auto").equals ("true")) {
                submission.setAutosubmitted ();
            }
            
            submission.save ();
        }
        catch (Exception e) {
           throw new ServletException (e);
        }
        
        String username = request.getParameter ("username");
        String password = request.getParameter ("password");
        
        request.getSession ().removeAttribute ("User");
        
        if (redirecturl == null) {
            redirecturl = "http://" + request.getServerName () + ":" + 
                    request.getServerPort () + 
                    "/jexweb/results.jsp?courseid=" +
                    URLEncoder.encode (courseid, "UTF-8") +
                    "&exerciseid=" +
                    URLEncoder.encode (exerciseid, "UTF-8") + 
                    "&username=" +
                    URLEncoder.encode (username, "UTF-8") + 
                    "&password=" +
                    URLEncoder.encode (password, "UTF-8");
        }
        redirecturl = redirecturl + "&submissionid=" + 
                URLEncoder.encode (Integer.toString (submission.getId ()),
                "UTF-8");
        response.getWriter ().write (redirecturl + "\r\n");
    }
}
