package no.ntnu.stud.frodesol.jexweb;
import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import java.net.URLEncoder;

import no.ntnu.stud.frodesol.jexserver.core.*;

import java.sql.PreparedStatement;
import java.util.*;
import org.apache.tomcat.util.http.fileupload.*;
import java.util.zip.*;

public class DownloadServlet extends BaseServlet {
    
    public void doGet(HttpServletRequest request,
            HttpServletResponse response)
            throws ServletException, IOException {
        
        ServletContext context = getServletContext ();
        
        Student student;
        try {
            student = getStudent (request); 
        }
        catch (Exception e) {
            if (request.getParameter("onlogin") != null) {
                response.sendRedirect (request.getParameter("onlogin"));
            }
            else {
                response.sendRedirect ("login.jsp");
            }
            return;
        }
        
        String courseid = request.getParameter ("courseid");
        String exerciseid = request.getParameter ("exerciseid");
        Exercise exercise = new Exercise (exerciseid);
        
        PreparedStatement stat = null;
        String eref = java.util.UUID.randomUUID ().toString () + "eref";
        try {
            Database database = Database.getInstance ();
            stat = database.prepareStatement ("INSERT " +
                    "INTO exerciseref (id, student, exercise) " +
                    "VALUES (?, ?, ?)");
            stat.setString (1, eref);
            stat.setString (2, student.getUserName());
            stat.setString (3, exercise.getId());
            stat.execute ();
        }
        catch (Exception e) {
            throw new ServletException(e);
        }
        finally {
            try {
                if (stat != null) stat.close();
            }
            catch (Exception e) {
                throw new ServletException(e);
            }
        }
        
        File tempfile = File.createTempFile("jexdownload", ".zip");
        ZipInputStream zin = null;
        ZipOutputStream zout = null;
        InputStream is = null;
        OutputStream os = null;
        byte[] buffer = new byte[2048];
        try {
            String zippath = exercise.getDistZipFilePath();
            //copyFile (new File(zippath), tempfile);
            
            zin = new ZipInputStream(new FileInputStream(zippath));
            zout = new ZipOutputStream(
                    new FileOutputStream(tempfile));
            
            ZipEntry entry = zin.getNextEntry();
            while (entry != null) {
                String name = entry.getName();
                // Add ZIP entry to output stream.
                zout.putNextEntry(new ZipEntry(name));
                // Transfer bytes from the ZIP file to the output file
                int len;
                while ((len = zin.read(buffer)) > 0) {
                    zout.write(buffer, 0, len);
                }
                if (name.endsWith(".jex")) {
                    //String submiturl = request.getParameter("submiturl");
                    
                    String submiturl = "http://" + request.getServerName () + 
                            ":" + request.getServerPort () + 
                            "/jexweb/submit_api.do?exerciseref=" +
                            URLEncoder.encode (eref, "UTF-8"); 
                    if (submiturl != null) {
                        name = name + ".submit";
                        zout.putNextEntry(new ZipEntry(name));
                        zout.write((submiturl + "\n").getBytes());
                    }
                }
                entry = zin.getNextEntry();
            }
            //zin.close();
            //zout.close();
            
            zout.close();
            
            is = new FileInputStream(tempfile);
            os = response.getOutputStream();
            
            String filename = "";
            String exname = exercise.getName();
            for (int i = 0; i < exname.length(); i++) {
                char c = exname.charAt(i);
                if ((c >= 'a' && c <= 'z') || (c >= 'A' && c <= 'Z') ||
                        (c >= '0' && c <= '9') || c == '-' || c == '_') {
                    filename = filename + c;
                }
                else {
                    filename = filename + '_';
                }
            }
            filename = filename + ".zip";
            
            response.setHeader("Content-Type", "application/zip");
            response.setHeader("Content-Disposition", "attachment; " +
            		"filename=\"" + filename + "\"");
            
            int len;
            while ((len = is.read(buffer)) > 0) {
                os.write(buffer, 0, len);
            }
        }
        catch (Exception e) {
            throw new ServletException(e);
        }
        finally {
            tempfile.delete();
            if (zin != null) zin.close();
            if (zout != null) zout.close();
            if (is != null) is.close();
            if (os != null) os.close();
        }
        
    }
    
    /*
    void copyFile(File src, File dest) throws IOException {
        InputStream is = new FileInputStream(src);
        OutputStream os = new FileOutputStream(dest);
    
        // Transfer bytes from in to out
        byte[] buf = new byte[2048];
        int len;
        while ((len = is.read(buf)) > 0) {
            os.write(buf, 0, len);
        }
        is.close();
        os.close();
    }
    */
}
