package no.ntnu.stud.frodesol.jexweb;
import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import no.ntnu.stud.frodesol.jexserver.core.*;
import java.util.*;
import org.apache.tomcat.util.http.fileupload.*;

public class NewExerciseServlet extends BaseServlet {
    
    public void doPost (HttpServletRequest request,
            HttpServletResponse response)
            throws ServletException, IOException {
        
        ServletContext context = getServletContext ();
        
        Student student;
        try {
            student = getStudent (request); 
        }
        catch (Exception e) {
            response.sendRedirect ("login.jsp");
            return;
        }
        
        if (student.isAdmin () == false) {
            throw new ServletException ("Admin access from non-admin user");
        }
        
        String courseid = request.getParameter ("courseid");
        //String exerciseid = request.getParameter ("exerciseid");
        //Exercise exercise = new Exercise (exerciseid);
        
        String name = request.getParameter ("name");
        if (name == null || name.length () == 0) {
            throw new ServletException ("Missing name");
        }
        
        Exercise exercise;
        try {
            exercise = Exercise.create (courseid, name);
        }
        catch (Exception e) {
            throw new ServletException (e.getMessage ());
        }
        
        response.sendRedirect ("exercise.jsp?courseid=" + courseid +
        		"&exerciseid=" + exercise.getId ()); 
        
    }
}
