package no.ntnu.stud.frodesol.jexweb;
import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import no.ntnu.stud.frodesol.jexserver.core.*;
import java.util.*;
import org.apache.tomcat.util.http.fileupload.*;
import no.ntnu.stud.frodesol.jexweb.imstool.*;

public class ReportResultServlet extends BaseServlet {
    
    public void doGet (HttpServletRequest request,
            HttpServletResponse response)
            throws ServletException, IOException {
        doPost(request, response);
    }
    
    public void doPost (HttpServletRequest request,
            HttpServletResponse response)
            throws ServletException, IOException {
        
        ServletContext context = getServletContext ();
        
        Student student;
        try {
            student = getStudent (request); 
        }
        catch (Exception e) {
            if (request.getParameter("onlogin") != null) {
                response.sendRedirect (request.getParameter("onlogin"));
            }
            else {
                response.sendRedirect ("login.jsp");
            }
            return;
        }
        
        String courseid = request.getParameter ("courseid");
        String exerciseid = request.getParameter ("exerciseid");
        Exercise exercise = new Exercise (exerciseid);
        
        // FIXME: Check that the student is allowed to access the
        // exercise+course
        
        String score = "0";
        try {
            Submission bestsub = student.getBestSubmissionForExercise(
                    exercise);
            if (bestsub != null && bestsub.isGraded()) {
                score = Integer.toString(bestsub.getScore());
            }
        }
        catch (Exception e) {
            throw new ServletException(e);
        }
        
        OutcomeServiceData osd = (OutcomeServiceData) request.getSession (
                ).getAttribute ("OutcomeServiceData");
        OutcomeReporter rep = new OutcomeReporter();
        try {
            rep.reportOutcome(osd, score/*"B"*//*score + "%"*/);
        }
        catch (Exception e) {
            throw new ServletException(e);
        }
        
        // Specific to its learning
        
        String[] pieces = osd.launchIdentifier.split("\\&");
        try {
            String url = "https://www.itslearning.com/ProxyTools/" +
                    "ProxyElementViewer.aspx?ProxyElementID=" + pieces[1];
            response.sendRedirect (url);
        }
        catch (Exception e) {
            
        }
        
        //response.sendRedirect (request.getParameter("onsuccess"));
    }
}
