package no.ntnu.stud.frodesol.jexweb;
import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import no.ntnu.stud.frodesol.jexserver.core.*;
import java.util.*;
import org.apache.tomcat.util.http.fileupload.*;

public class SubmitServlet extends BaseServlet {
    
    public void doPost (HttpServletRequest request,
            HttpServletResponse response)
            throws ServletException, IOException {
        
        ServletContext context = getServletContext ();
        
        Student student;
        try {
            student = getStudent (request); 
        }
        catch (Exception e) {
            if (request.getParameter("onlogin") != null) {
                response.sendRedirect (request.getParameter("onlogin"));
            }
            else {
                response.sendRedirect ("login.jsp");
            }
            return;
        }
        
        String courseid = request.getParameter ("courseid");
        String exerciseid = request.getParameter ("exerciseid");
        Exercise exercise = new Exercise (exerciseid);
        
        // FIXME: Check that the student is allowed to access the
        // exercise+course
        
        Submission submission;
        
        FileUpload fileupload = new FileUpload ();
        fileupload.setFileItemFactory (new DefaultFileItemFactory ());
        try {
            List<FileItem> fileitems = fileupload.parseRequest (request);
            // There should be only one file
            FileItem fileitem = fileitems.get (0);
            
            submission = new Submission (exercise, student);
            fileitem.write (new java.io.File (submission.getZipFilePath ()));
            submission.save ();
        }
        catch (Exception e) {
           throw new ServletException (e);
        }
        
        if (request.getParameter("onsuccess") != null) {
            response.sendRedirect (request.getParameter("onsuccess") + 
                    "&submissionid=" + submission.getId ());             
        }
        else {
            response.sendRedirect ("submission.jsp?courseid=" + courseid +
            		"&exerciseid=" + exerciseid + "&submissionid=" + 
            		submission.getId ()); 
        }
    }
}
