package no.ntnu.stud.frodesol.jexweb;
import javax.servlet.http.*;
import javax.servlet.*;
import java.io.*;
import no.ntnu.stud.frodesol.jexserver.core.*;

import java.util.*;
import org.apache.tomcat.util.http.fileupload.*;
import java.net.URLEncoder;

import com.oreilly.servlet.MultipartRequest;

// This servlet is used for collection submissions from students for the
// master's thesis spring 2008.

public class TempSubmitServlet extends BaseServlet {
    
    public Student getTheStudent (MultipartRequest request,
            boolean createondemand) throws Exception {
        //String username = "test" + request.getParameter ("username");
        
        if (request.getParameter ("username").compareTo ("") == 0) {
            throw new Exception("Trenger gyldig e-postadresse eller brukernavn");
        }
        
        String username = "test_" + request.getParameter ("username");
        String password = "test_" + request.getParameter ("username");
        
        
        
        User user;
        try {
             user = authenticate (username, password, createondemand);
        }
        catch (AuthenticationException e) {
            throw new Exception ("Could not create user");
        }
        return user.getStudent ();
    }
    
    public void doPost (HttpServletRequest request,
            HttpServletResponse response)
            throws ServletException, IOException {
        
        //ServletContext context = getServletContext ();
        
        String tempdir = System.getProperty("java.io.tmpdir");
        MultipartRequest mreq = new MultipartRequest (request, tempdir);
        
        String courseid = request.getParameter ("courseid");
        if (courseid == null) {
            response.sendError (400, "No courseid specified");
            return;
        }
        
        if (courseid.compareTo ("TDT4100-2008") == 0) {
            courseid = "TDT4100-V08";
        }
        
        Student student;
        try {
            student = getTheStudent (mreq, true); 
        }
        catch (Exception e) {
            //response.sendRedirect ("login.jsp");
            response.sendError (401, e.getMessage());
            return;
        }
        
        try {
            student.attendCourse (courseid);
        }
        catch (Exception e) {
            response.sendError (500, "Error adding student to course");
        }
        
        String exerciseid = request.getParameter ("exerciseid");
        if (exerciseid == null) {
            exerciseid = request.getParameter ("amp;exerciseid");
            if (exerciseid == null) {
                response.sendError (400, "No exerciseid specified");
                return;
            }
        }
        
        Exercise exercise;// = new Exercise (exerciseid);
        try {
            exercise = Exercise.get (exerciseid);
        }
        catch (Exception e) {
            try {
                exercise = Exercise.findByNameAndCourse (exerciseid, courseid);
            }
            catch (Exception e2) {            
                response.sendError (500, "Could not load exercise");
                return;
            }
        }
        // FIXME: Check that the student is allowed to access the
        // exercise+course
        
        Submission submission;
        
        try {
            submission = new Submission (exercise, student);
            java.io.File srcfile = mreq.getFile ("submission");
            java.io.File destfile = new java.io.File (submission.getZipFilePath ());
            srcfile.renameTo (destfile);
            
            submission.save ();
        }
        catch (Exception e) {
            throw new ServletException (e);
         }
        /*
        FileUpload fileupload = new FileUpload ();
        fileupload.setFileItemFactory (new DefaultFileItemFactory ());
        try {
            List<FileItem> fileitems = fileupload.parseRequest (request);
            // There should be only one file
            FileItem fileitem = fileitems.get (0);
            
            submission = new Submission (exercise, student);
            fileitem.write (new java.io.File (submission.getZipFilePath ()));
            
            if (request.getParameter ("auto") != null &&
                    request.getParameter ("auto").equals ("true")) {
                submission.setAutosubmitted ();
            }
            
            submission.save ();
        }
        catch (Exception e) {
           throw new ServletException (e);
        }
        */
        /*
        String username = request.getParameter ("username");
        String password = request.getParameter ("password");
        */
        //request.getSession ().removeAttribute ("User");
        
        String url = "http://" + request.getServerName () + ":" + 
                request.getServerPort () + 
                "/jexweb/innlevering/takk.html";
        response.sendRedirect (url); 
        
    }
}
