package no.ntnu.stud.frodesol.jexweb;
import javax.servlet.http.*;
import javax.servlet.*;

import java.io.*;
import no.ntnu.stud.frodesol.jexserver.core.*;
import java.util.*;
import org.apache.tomcat.util.http.fileupload.*;

public class UploadExerciseServlet extends BaseServlet {
    
    public void doPost (HttpServletRequest request,
            HttpServletResponse response)
            throws ServletException, IOException {
        
        ServletContext context = getServletContext ();
        
        Student student;
        try {
            student = getStudent (request); 
        }
        catch (Exception e) {
            response.sendRedirect ("login.jsp");
            return;
        }
        
        if (student.isAdmin () == false) {
            throw new ServletException ("Admin access from non-admin user");
        }
        
        String courseid = request.getParameter ("courseid");
        String exerciseid = request.getParameter ("exerciseid");
        Exercise exercise = new Exercise (exerciseid);
        
        // FIXME: Check that the admin is allowed to access the
        // exercise+course
        
        Submission submission;
        
        FileUpload fileupload = new FileUpload ();
        fileupload.setFileItemFactory (new DefaultFileItemFactory ());
        try {
            List<FileItem> fileitems = fileupload.parseRequest (request);
            
            for (int i = 0; i < fileitems.size(); i++) {
                FileItem fileitem = fileitems.get (i);
                if (fileitem.getFieldName().equals("testzip")) {
                    if (fileitem.getSize() > 0) {
                        //submission = new Submission (exercise, student);
                        fileitem.write(new java.io.File(exercise.getNewZipFilePath ()));
                        exercise.updateWithNewZip ();
                    }
                }
                else if (fileitem.getFieldName().equals("distzip")) {
                    if (fileitem.getSize() > 0) {
                        fileitem.write(new java.io.File(exercise.getDistZipFilePath ()));
                    }
                }
            }
        }
        catch (Exception e) {
           throw new ServletException (e);
        }
        
        response.sendRedirect ("exercise.jsp?courseid=" + courseid +
        		"&exerciseid=" + exerciseid); 
        
    }
}
