
package no.ntnu.stud.frodesol.jexweb.imstool;

import no.ntnu.stud.frodesol.jexweb.*;
import java.net.URLEncoder;
import java.rmi.RemoteException;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import org.apache.axis.transport.http.HTTPConstants;
import org.apache.axis.MessageContext;
import org.imsglobal.www.services.ti.wsdl.sync.TIRLaunchService_v1p0.*;
import org.imsglobal.www.services.ti.wsdl.sync.TIRLaunchService_v1p0.holders.*;

import com.sun.jmx.remote.internal.RMIExporter;
import no.ntnu.stud.frodesol.jexserver.core.*;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.XPath;
import org.dom4j.io.SAXReader;

public class LaunchService {
    /*
    public void proxyToolLaunchSimple() {
       
    }
    */
    
    public void proxyToolLaunch(
            ProxyToolLaunchRequest parameters,
            Imsx_RequestHeaderInfoType headerInfoParameters,
            ProxyToolLaunchResponseHolder response,
            Imsx_ResponseHeaderInfoTypeHolder headerInfoResponse)
            throws java.rmi.RemoteException {
        
        try {
            proxyToolLaunchImpl(parameters, headerInfoParameters, response, 
                    headerInfoResponse);
        }
        catch (Throwable e) {
            throw new RemoteException(e.getMessage(), e);
        }
    }
    
    private void proxyToolLaunchImpl(
            ProxyToolLaunchRequest parameters,
            Imsx_RequestHeaderInfoType headerInfoParameters,
            ProxyToolLaunchResponseHolder response,
            Imsx_ResponseHeaderInfoTypeHolder headerInfoResponse)
            throws Exception {
        
        System.out.println("GOT LAUNCH REQUEST");
        MessageContext messageContext = MessageContext.getCurrentContext();
        ServletContext servletContext = ((HttpServlet)
                messageContext.getProperty(
                HTTPConstants.MC_HTTP_SERVLET)).getServletContext();
        HttpServletRequest request = (HttpServletRequest)
                messageContext.getProperty(
                HTTPConstants.MC_HTTP_SERVLETREQUEST);
        
        response.value = new ProxyToolLaunchResponse();
        headerInfoResponse.value = new Imsx_ResponseHeaderInfoType();
        
        String msgid = headerInfoParameters.getImsx_messageIdentifier();
        headerInfoResponse.value.setImsx_messageIdentifier(msgid);
        Imsx_StatusInfoType statusinfo = createStatusInfoType(
                Imsx_CodeMajorType.fromValue("success"), "", msgid, 
                Imsx_SeverityType.fromValue("status"));
        headerInfoResponse.value.setImsx_statusInfo(statusinfo);
        
        LaunchDirectiveType launchDirective = new LaunchDirectiveType();
        
        // Find student
        
        System.out.println("Find student");
        
        SimpleUserProfileType userprofile = (SimpleUserProfileType) 
                parameters.getContextualSettings().getUserProfile();
        String userid = userprofile.getUserid();
        String firstname = userprofile.getFirstName();
        String lastname = userprofile.getLastName();
        
        String username = "itslearning:" + userid;
        System.out.println("Check username " + username);
        
        Student student = null;
        try {
            student = Student.findByCredentials(username, false);
        }
        catch (Exception e) {
            System.out.println("ERROR e " + e.getMessage());
            try {
                student = Student.create(username, firstname + " " + lastname,
                        userprofile.getAncillary());
            }
            catch (Exception e2) {
                System.out.println("ERROR e2 " + e2.getMessage());
                throw new Exception("Could not log in student", e2);
            }
        }
        
        
        
        
        
        String toolAncillary = null;
        if (parameters.getToolSettings()!= null) {
            toolAncillary = parameters.getToolSettings().getAncillary();
            if (toolAncillary == null || toolAncillary.length() == 0) {
                throw new Exception("No tool ancillary settings");
            }
        }
        
        SAXReader xmlReader = new SAXReader();
        HashMap namespaceURIs = new HashMap();
        namespaceURIs.put("tool", 
                "http://frodesol.stud.ntnu.no/jexserver/proxytool/1.0");
        Document doc = xmlReader.read(new StringReader(toolAncillary));
        /*
        String course = doc.getRootElement().valueOf("/resourceIdentifier/course");
        if (course == null || course.length() == 0) {
            throw new Exception("Missing course in request");
        }
        */
        XPath xpath = doc.createXPath("/tool:resourceIdentifier/tool:course");
        xpath.setNamespaceURIs(namespaceURIs);
        String course = xpath.valueOf(doc);
        if (course == null || course.length() == 0) {
            throw new Exception("Missing course in request");
        }
        xpath = doc.createXPath("/tool:resourceIdentifier/tool:exercise");
        xpath.setNamespaceURIs(namespaceURIs);
        String exercise = xpath.valueOf(doc);
        if (exercise == null || exercise.length() == 0) {
            throw new Exception("Missing exercise in request");
        }
        xpath = doc.createXPath("/tool:resourceIdentifier/tool:method");
        xpath.setNamespaceURIs(namespaceURIs);
        String method = xpath.valueOf(doc);
        if (method == null || method.length() == 0) {
            method = "";
        }
        
        /*
                // Try using the namespace "http://engage.doit.wisc.edu/schemas/ConceptTutor_v1p0"
                XPath xpath = doc.createXPath("/ct:resourceIdentifier/ct:id");
                xpath.setNamespaceURIs(namespaceURIs);
                resourceIdentifier = xpath.valueOf(doc);
            }
            if (resourceIdentifier == null || "".equals(resourceIdentifier)) {
                statusInfo = createStatusInfoType(Imsx_CodeMajorType.fromValue("failure"),
                                                 "Missing resourceIdentifier",
                                                 receivedMessageId,
                                                 Imsx_SeverityType.fromValue("error"));
                setLaunchDirective("Missing resource identifier", "", response.value);
            } else {
                setLaunchDirective("", baseUrl + resourceIdentifier + "?sessionId=" + sessionId, response.value);
            }
        } else {
            statusInfo = createStatusInfoType(Imsx_CodeMajorType.fromValue("failure"),
                                               "Missing ToolSettings/Ancillary data",
                                               receivedMessageId,
                                               Imsx_SeverityType.fromValue("error"));
            setLaunchDirective("Missing ToolSettings/Ancillary data", "", response.value);
        }
    }
} catch (Exception ex) {
    log.error(ex.getClass().getName() + " Exception: " + ex.getMessage(), ex);
    statusInfo = handleException(ex, receivedMessageId);
}
    */
    
        
        
        
        
        
        
        
        
        
        
        System.out.println("Found user " + username);
        
        // Create a new session
        HttpSession session = request.getSession(true);
        
        String sessionid = session.getId();
        System.out.println("Session");
        System.out.println(sessionid);
        
        //session.setAttribute("course", course);
        //session.setAttribute("exercise", exercise);
        session.setAttribute("User", new User(student));
        String exerciseid = Exercise.findByNameAndCourse(exercise,
                course).getId(); 
        
        OutcomeServiceData osd = new OutcomeServiceData();
        osd.launchIdentifier = parameters.getContextualSettings(
                ).getLaunchProfile().getLaunchIdentifier();
        osd.launchRole = parameters.getContextualSettings(
                ).getLaunchProfile().getRole();
        osd.launchType = parameters.getContextualSettings(
                ).getLaunchProfile().getLaunchType();
        osd.messageId = msgid;
        osd.endpointURL = parameters.getCoreSettings().getTIR(
                ).getOutcomeService().getServiceLocation();
        
        session.setAttribute("OutcomeServiceData", osd);
        /*
        String outcomeaddress = parameters.getCoreSettings().getTIR(
                ).getOutcomeService().getServiceLocation();
        String outcomeaddress = parameters.getCoreSettings().getTIR(
                ).getOutcomeService().getServiceLocation();
        */
        
        String url;
        try {
            /*
            url = "http://" + request.getServerName () + ":" + 
                    request.getServerPort () + 
                    "/jexweb/imstool/exercise.jsp?jsessionid=" +
                    URLEncoder.encode(sessionid, "UTF-8");
            */
            url = "http://" + request.getServerName () + ":" + 
            request.getServerPort () + 
            "/jexweb/itslearning/exercise.jsp?courseid=" +
            URLEncoder.encode (course, "UTF-8") +
            "&exerciseid=" +
            URLEncoder.encode (exerciseid, "UTF-8") + 
            "&jsessionid=" +
            URLEncoder.encode (sessionid, "UTF-8");
        }
        catch (Exception e) {
            System.out.println(e.getMessage());
            throw new RemoteException("Could not create URL", e);
        }
        
        System.out.println("Redirect URL = " + url);
        
        launchDirective.setPerformRedirectAction(url);
        response.value.setLaunchDirective(launchDirective);
    }
    
    private Imsx_StatusInfoType createStatusInfoType(
            Imsx_CodeMajorType codeMajor, String description, 
            String messageIdentifier, Imsx_SeverityType severity) {
        Imsx_StatusInfoType statusInfo = new Imsx_StatusInfoType(codeMajor,
                severity, messageIdentifier, new String[0], description,
                new Imsx_CodeMinorFieldType[0]);
        return statusInfo;
    }
}

/*
package org.imsglobal.www.services.ti.wsdl.sync.TIRLaunchService_v1p0;
import no.ntnu.stud.frodesol.jexweb.ims.LaunchService;
public class TIRLaunchServiceSyncSoapBindingImpl implements org.imsglobal.www.services.ti.wsdl.sync.TIRLaunchService_v1p0.TIRLaunchServiceSyncPortType{
    public void proxyToolLaunch(org.imsglobal.www.services.ti.wsdl.sync.TIRLaunchService_v1p0.ProxyToolLaunchRequest parameters, org.imsglobal.www.services.ti.wsdl.sync.TIRLaunchService_v1p0.Imsx_RequestHeaderInfoType headerInfoParameters, org.imsglobal.www.services.ti.wsdl.sync.TIRLaunchService_v1p0.holders.ProxyToolLaunchResponseHolder response, org.imsglobal.www.services.ti.wsdl.sync.TIRLaunchService_v1p0.holders.Imsx_ResponseHeaderInfoTypeHolder headerInfoResponse) throws java.rmi.RemoteException {
        LaunchService service = new LaunchService();
        service.proxyToolLaunch(parameters, headerInfoParameters, response, headerInfoResponse);
    }
}
*/
