package no.ntnu.stud.frodesol.jexweb.imstool;

//import org.imsglobal.www.services.ti.wsdl.sync.TIRLaunchService_v1p0.*;
//import org.imsglobal.www.services.ti.wsdl.sync.TIRLaunchService_v1p0.holders.*;
import java.net.URL;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.imsglobal.www.services.ti.wsdl.sync.TIROutcomeService_v1p0.*;
import org.imsglobal.www.services.ti.wsdl.sync.TIROutcomeService_v1p0.holders.*;


public class OutcomeReporter {
    
    public void reportOutcome(OutcomeServiceData sd, String score)
            throws Exception {
        TIROutcomeSyncService service = new TIROutcomeSyncServiceLocator();
        TIROutcomeServiceSyncPortType port = 
                service.getTIROutcomeServiceSyncSoapPort(
                new java.net.URL(sd.endpointURL));

        LaunchProfileType launchprofile = new LaunchProfileType(
                sd.launchIdentifier, sd.launchRole, sd.launchType);
        OutcomeProfileType outcomeProfile;
        outcomeProfile = new MinimalOutcomeProfileType(launchprofile, score);
        OutcomeMessageRequest request = new OutcomeMessageRequest(
                outcomeProfile);
        Imsx_RequestHeaderInfoType headerinfo = new Imsx_RequestHeaderInfoType();

        // Look up shared secret key
        String secret = "";
        try {
            Context env = (Context) new InitialContext ().lookup (
                    "java:comp/env");
            secret = (String) env.lookup ("IMS_TI_TOOL_SECRET");
        }
        catch (NamingException e) {
            
        }
        
        if (secret.length() > 0) {
            SharedSecretSecurityProfileType secprofile = 
                    new SharedSecretSecurityProfileType();
            //securityProfile.setMAC(MACUtilities.generateBase64EncodedMAC(messageId, sharedSecret));
            headerinfo.setSecurityProfile(secprofile);
        }
        headerinfo.setImsx_messageIdentifier(sd.messageId);
        Imsx_ResponseHeaderInfoTypeHolder responseheaderholder = 
                new Imsx_ResponseHeaderInfoTypeHolder();
        OutcomeMessageResponseHolder responseholder = 
                new OutcomeMessageResponseHolder();
        
        
        port.outcomeMessage(request, headerinfo, responseholder,
                responseheaderholder);
        
        Imsx_ResponseHeaderInfoType responseheader = 
                responseheaderholder.value;
        Imsx_StatusInfoType statusinfo = responseheader.getImsx_statusInfo();
        if (statusinfo.getImsx_codeMajor().toString().equals("success")) {
            // success
            System.out.println("Report score -- success");
        }
        else {
            System.out.println("Report score -- failure");
            System.out.println("Status: '" + statusinfo.getImsx_codeMajor() + 
                    "'");
            System.out.println(statusinfo.getImsx_description());
            throw new Exception("Could not report status");
        }
        
        // Specific to its learning
        /*
        String[] pieces = sd.launchIdentifier.split("\\&");
        try {
            String url = "https://www.itslearning.com/ProxyTools/" +
                    "ProxyElementViewer.aspx?ProxyElementID=" + pieces[1];
        }
        catch (Exception e) {
            
        }
        */
        //responseheaders.
    }
}
